package com.zhibao.crm.erp.admin.controller;

import cn.hutool.core.util.IdUtil;
import com.jfinal.aop.Inject;
import com.jfinal.core.Controller;
import com.jfinal.core.paragetter.Para;
import com.zhibao.crm.common.annotation.AdminSysLog;
import com.zhibao.crm.common.annotation.NotNullValidate;
import com.zhibao.crm.common.annotation.NotNullValidates;
import com.zhibao.crm.common.config.paragetter.BasePageRequest;
import com.zhibao.crm.erp.admin.entity.AdminScene;
import com.zhibao.crm.erp.admin.service.AdminSceneService;

public class AdminSceneController extends Controller {

   @Inject
   private AdminSceneService adminSceneService;


   @NotNullValidate(
      value = "label",
      message = "label不能为空"
   )
   public void queryField(@Para("label") Integer label) {
      this.renderJson(this.adminSceneService.queryField(label));
   }

   @NotNullValidates({      @NotNullValidate(
         value = "type",
         message = "type不能为空"
      ),       @NotNullValidate(
         value = "name",
         message = "场景名称不能为空"
      ),       @NotNullValidate(
         value = "data",
         message = "data不能为空"
      )})
   public void addScene(@Para("") AdminScene adminScene) {
      this.renderJson(this.adminSceneService.addScene(adminScene));
   }

   @NotNullValidate(
      value = "sceneId",
      message = "场景id不能为空"
   )
   public void updateScene(@Para("") AdminScene adminScene) {
      this.renderJson(this.adminSceneService.updateScene(adminScene));
   }

   @NotNullValidate(
      value = "sceneId",
      message = "场景id不能为空"
   )
   public void setDefaultScene(@Para("sceneId") Integer sceneId) {
      this.renderJson(this.adminSceneService.setDefaultScene(sceneId));
   }

   @NotNullValidate(
      value = "sceneId",
      message = "场景id不能为空"
   )
   public void deleteScene(@Para("") AdminScene adminScene) {
      this.renderJson(this.adminSceneService.deleteScene(adminScene));
   }

   @NotNullValidate(
      value = "type",
      message = "type不能为空"
   )
   public void queryScene(@Para("type") Integer type) {
      this.renderJson(this.adminSceneService.queryScene(type));
   }

   @NotNullValidate(
      value = "type",
      message = "type不能为空"
   )
   public void querySceneConfig(@Para("") AdminScene adminScene) {
      this.renderJson(this.adminSceneService.querySceneConfig(adminScene));
   }

   @NotNullValidates({      @NotNullValidate(
         value = "type",
         message = "type不能为空"
      ),       @NotNullValidate(
         value = "noHideIds",
         message = "显示场景不能为空"
      )})
   public void sceneConfig(@Para("") AdminScene adminScene) {
      this.renderJson(this.adminSceneService.sceneConfig(adminScene));
   }

   @AdminSysLog("查看列表")
   public void queryPageList(BasePageRequest basePageRequest) {
      this.renderJson(this.adminSceneService.filterConditionAndGetPageList(basePageRequest));
   }

   public static void main(String[] args) {
      for(int i = 0; i < 150; ++i) {
         System.out.println(IdUtil.fastSimpleUUID());
      }

   }
}
